Attribute VB_Name = "modFocus"
Option Explicit

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
        (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, _
        ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
        (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Const GWL_WNDPROC = -4
Private Const WM_ACTIVATEAPP = &H1C

' Locale Variablen:
Private mainOldProc As Long       ' Pointer auf original Fensterprozedur

Global glbAppActive As Boolean    ' globale berwachungsvariable

' Subclassing initialisieren:
Public Sub MainHook(ByVal hWnd As Long)
  glbAppActive = True ' Wenn wir starten, sind wir die aktive Anwendung
  mainOldProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf winMain)
End Sub

' Subclassing beenden:
Public Sub MainUnHook(ByVal hWnd As Long)
  SetWindowLong hWnd, GWL_WNDPROC, mainOldProc
End Sub

' Unsere Erweiterung der Fensterprozedur:
Private Function winMain(ByVal hWnd&, ByVal uMsg&, ByVal wParam&, ByVal lParam&) As Long
  Select Case uMsg
    Case WM_ACTIVATEAPP
      If wParam Then  ' Anwendung wurde aktiviert
        glbAppActive = True
      Else            ' Anwendung wurde deaktiviert
        glbAppActive = False
      End If
  End Select
  winMain = CallWindowProc(mainOldProc, hWnd, uMsg, wParam, lParam)
End Function

